HDU 3535-AreYouBusy

来源:互联网 发布:云计算行业报告 编辑:程序博客网 时间:2024/05/18 01:49

AreYouBusy

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4557    Accepted Submission(s): 1850


题目链接:点击打开链接



Problem Description
Happy New Term!
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.
What's more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss's advice)?
 

Input
There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.
 

Output
One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .

Sample Input
3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1


3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1


1 1
1 0
2 1


5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10
 


Sample Output
5
13
-1
-1


题意:

每一个测试用例以两个整数 n 和 T 开始,n 代表 n 组作业,T 代表有 T 分钟来做它们。然后有 n 组工作的描述,每组描述都始于两个整数 m 和 s ,m 代表在这组里有 m 个工作,s 代表该组的集合类型,s 有三种类型,分别是 0,1,2(0 代表集在该组中至少选择一个工作要做,1 代表在该组中最多选择一个工作来做,2 代表在该组中你随意,选或者不选,选多少都可以)。然后,m对整数ci,gi,代表着该组中第 i 个工作花需要花费 ci 分钟完成,可以获得 gi 个幸福点,让你找到一种选择可以从所有作业中获得最大幸福点。如果不能按要求完成工作,就输出

- 1。



分析:

分组背包问题(也叫混合背包吧),第一次做,也是悟学长的思想才懂的,简单来分析分析吧!

题目给了很多类别的物品。用数组dp[i][j],表示第i组,时间为j时的快乐值。每得到一组工作就进行一次dp,所以dp[i]为第i组的结果。

第一类(01背包坑点多):至少选一项,即必须要选,那么在开始时,对于这一组的dp的初值,应该全部赋为负无穷,这样才能保证不会出现都不选的情况。

状态转移方程:dp[i][j]=max(dp[i][j],max(dp[i][j-w[x]]+p[x],dp[i-1][j-w[x]]+p[x]));

dp[i][j]: 是不选择当前工作(但一般如果是第一次取的话肯定不会选这种状态,因为初始值都为负无穷);

dp[i-1][j-w[x]]+p[x]: 第一次在本组中选物品,由于开始将该组dp赋为了负无穷,所以第一次取时,必须由上一组的结果推知,这样才能保证得到全局最优解;

dp[i][j-w[x]]+p[x]:表示选择当前工作,并且不是第一次取;

第二类(分组背包):最多选一项,即要么不选,一旦选,只能是第一次选。

状态转移方程:dp[i][j]=max(dp[i][j],dp[i-1][j-w[x]]+p[x]);

由于要保证得到全局最优解,所以在该组 dp 开始之前,应该将上一组的 dp 结果先复制到这一组的 dp[i] 数组里,因为当前组的数据是在上一组数据的基础上进行更新的。

第三类(01背包):任意选,选不选都行,选几个都可以。

状态转移方程为:dp[i][j]=max(dp[i][j],dp[i][j-w[x]]+p[x]);

同样要保证为得到全局最优解,先复制上一组解,数据在当前组更新。



#include<iostream>#include<stdio.h>#include<string>#include<string.h>#include<algorithm>using namespace std;const int INF=0x3f3f3f3f;int n,m,sum;int w[110],p[110];int dp[110][110];int main(){    while(~scanf("%d%d",&n,&sum))    {        memset(dp,0,sizeof(dp));        int g;        for(int i=1; i<=n; i++)        {            scanf("%d%d",&m,&g);            for(int k=1; k<=m; k++)                scanf("%d%d",&w[k],&p[k]);            if(g==0)            {                for(int j=0; j<=sum; j++) //当前组初始化                    dp[i][j]=-INF;                for(int k=1; k<=m; k++)                    for(int j=sum; j>=w[k]; j--)                        dp[i][j]=max(dp[i][j],max(dp[i][j-w[k]]+p[k],dp[i-1][j-w[k]]+p[k]));            }            else if(g==1)            {                for(int j=0; j<=sum; j++) //当前组初始化                    dp[i][j]=dp[i-1][j];                for(int k=1; k<=m; k++)                    for(int j=sum; j>=w[k]; j--)                        dp[i][j]=max(dp[i][j],dp[i-1][j-w[k]]+p[k]);            }            else if(g==2)            {                for(int j=0; j<=sum; j++) //当前组初始化                    dp[i][j]=dp[i-1][j];                for(int k=1; k<=m; k++)                    for(int j=sum; j>=w[k]; j--)                        dp[i][j]=max(dp[i][j],dp[i][j-w[k]]+p[k]);            }        }        dp[n][sum]=max(dp[n][sum],-1);  //没有完成任务的值都为负的,做输出调整,输出-1        printf("%d\n",dp[n][sum]);    }    return 0;}




 
原创粉丝点击